module win32.ascii;

import std.c.windows.windows;
import win32.windef;
import win32.wingdi;
import win32.winuser;

version(UNICODE) {
	//#error UNICODE has included the win32ascii module
} else { // version(UNICODE)
extern(Windows) {
alias PostThreadMessageA PostAppMessageA;
alias LOGFONTA LOGFONT;
alias PLOGFONTA PLOGFONT;
alias NPLOGFONTA NPLOGFONT;
alias LPLOGFONTA LPLOGFONT;
alias ENUMLOGFONTA ENUMLOGFONT;
alias LPENUMLOGFONTA LPENUMLOGFONT;
alias ENUMLOGFONTEXA ENUMLOGFONTEX;
alias LPENUMLOGFONTEXA LPENUMLOGFONTEX;
alias EXTLOGFONTA EXTLOGFONT;
alias PEXTLOGFONTA PEXTLOGFONT;
alias NPEXTLOGFONTA NPEXTLOGFONT;
alias LPEXTLOGFONTA LPEXTLOGFONT;
alias DEVMODEA DEVMODE;
alias PDEVMODEA PDEVMODE;
alias NPDEVMODEA NPDEVMODE;
alias LPDEVMODEA LPDEVMODE;
	alias OUTLINETEXTMETRICA OUTLINETEXTMETRIC;
	alias POUTLINETEXTMETRICA POUTLINETEXTMETRIC;
	alias NPOUTLINETEXTMETRICA NPOUTLINETEXTMETRIC;
	alias LPOUTLINETEXTMETRICA LPOUTLINETEXTMETRIC;
	alias POLYTEXTA POLYTEXT;
	alias PPOLYTEXTA PPOLYTEXT;
	alias NPPOLYTEXTA NPPOLYTEXT;
	alias LPPOLYTEXTA LPPOLYTEXT;
	alias GCP_RESULTSA GCP_RESULTS;
	alias LPGCP_RESULTSA LPGCP_RESULTS;
alias OSVERSIONINFOA OSVERSIONINFO;
alias POSVERSIONINFOA POSVERSIONINFO;
alias LPOSVERSIONINFOA LPOSVERSIONINFO;
alias LOGCOLORSPACEA LOGCOLORSPACE;
alias LPLOGCOLORSPACEA LPLOGCOLORSPACE;
alias BYTE BCHAR;
alias TEXTMETRICA TEXTMETRIC;
alias PTEXTMETRICA PTEXTMETRIC;
alias NPTEXTMETRICA NPTEXTMETRIC;
alias LPTEXTMETRICA LPTEXTMETRIC;
alias NEWTEXTMETRICEXA NEWTEXTMETRICEX;
alias NEWTEXTMETRICA NEWTEXTMETRIC;
alias PNEWTEXTMETRICA PNEWTEXTMETRIC;
alias NPNEWTEXTMETRICA NPNEWTEXTMETRIC;
alias LPNEWTEXTMETRICA LPNEWTEXTMETRIC;
	alias HW_PROFILE_INFOA HW_PROFILE_INFO;
	alias LPHW_PROFILE_INFOA LPHW_PROFILE_INFO;
	alias STARTUPINFOA STARTUPINFO;
	alias LPSTARTUPINFOA LPSTARTUPINFO;
	version(STANDALONE) alias WIN32_FIND_DATAA WIN32_FIND_DATA;
	alias PWIN32_FIND_DATAA PWIN32_FIND_DATA;
	alias LPWIN32_FIND_DATAA LPWIN32_FIND_DATA;
	alias SOUNDSENTRYA SOUNDSENTRY;
	alias LPSOUNDSENTRYA LPSOUNDSENTRY;
	alias SERIALKEYSA SERIALKEYS;
	alias LPSERIALKEYSA LPSERIALKEYS;
	alias HIGHCONTRASTA HIGHCONTRAST;
	alias LPHIGHCONTRASTA LPHIGHCONTRAST;
	alias ICONMETRICSA ICONMETRICS;
	alias PICONMETRICSA PICONMETRICS;
	alias LPICONMETRICSA LPICONMETRICS;
	alias NONCLIENTMETRICSA NONCLIENTMETRICS;
	alias PNONCLIENTMETRICSA PNONCLIENTMETRICS;
	alias LPNONCLIENTMETRICSA LPNONCLIENTMETRICS;
	alias HELPWININFOA HELPWININFO;
	alias PHELPWININFOA PHELPWININFO;
	alias LPHELPWININFOA LPHELPWININFO;
	alias MULTIKEYHELPA MULTIKEYHELP;
	alias PMULTIKEYHELPA PMULTIKEYHELP;
	alias LPMULTIKEYHELPA LPMULTIKEYHELP;
	alias MDICREATESTRUCTA MDICREATESTRUCT;
	alias LPMDICREATESTRUCTA LPMDICREATESTRUCT;
	alias MSGBOXPARAMSA MSGBOXPARAMS;
	alias PMSGBOXPARAMSA PMSGBOXPARAMS;
	alias LPMSGBOXPARAMSA LPMSGBOXPARAMS;
	alias LPCMENUITEMINFOW LPCMENUITEMINFO;
	alias MENUITEMINFOA MENUITEMINFO;
	alias LPMENUITEMINFOA LPMENUITEMINFO;
        
	version(STANDALONE) alias  LPDLGTEMPLATEA LPDLGTEMPLATE;
	version(STANDALONE) alias  DLGTEMPLATE * LPCDLGTEMPLATEA;
	version(STANDALONE) alias LPCDLGTEMPLATEA LPCDLGTEMPLATE;

	alias PDLGITEMTEMPLATEA PDLGITEMTEMPLATE;
	alias LPDLGITEMTEMPLATEA LPDLGITEMTEMPLATE;
	alias CREATESTRUCTA CREATESTRUCT;
	alias LPCREATESTRUCTA LPCREATESTRUCT;
//	alias WNDCLASSA WNDCLASS;
	alias PWNDCLASSA PWNDCLASS;
	alias NPWNDCLASSA NPWNDCLASS;
	alias LPWNDCLASSA LPWNDCLASS;
	alias WNDCLASSEXA WNDCLASSEX;
	alias PWNDCLASSEXA PWNDCLASSEX;
	alias NPWNDCLASSEXA NPWNDCLASSEX;
	alias LPWNDCLASSEXA LPWNDCLASSEX;
	alias MENUTEMPLATEA MENUTEMPLATE;
	alias LPMENUTEMPLATEA LPMENUTEMPLATE;
	alias PROPENUMPROCA        PROPENUMPROC;
	alias PROPENUMPROCEXA      PROPENUMPROCEX;
	alias EDITWORDBREAKPROCA   EDITWORDBREAKPROC;
	alias WINSTAENUMPROCA     WINSTAENUMPROC;
	alias DESKTOPENUMPROCA    DESKTOPENUMPROC;
	LPSTR  MAKEINTRESOURCE(int i) { return cast(LPSTR)(cast(DWORD)(cast(WORD)(i))); }
	alias CBT_CREATEWNDA CBT_CREATEWND;
	alias LPCBT_CREATEWNDA LPCBT_CREATEWND;

alias OLDFONTENUMPROCA OLDFONTENUMPROC;
alias FONTENUMPROCA FONTENUMPROC;
alias DOCINFOA DOCINFO;
alias LPDOCINFOA LPDOCINFO;
alias ICMENUMPROCA ICMENUMPROC;

	alias LoadKeyboardLayoutA LoadKeyboardLayout;
	alias GetKeyboardLayoutNameA GetKeyboardLayoutName;
	alias CreateDesktopA CreateDesktop;
	alias OpenDesktopA OpenDesktop;
	alias EnumDesktopsA  EnumDesktops;
	alias CreateWindowStationA CreateWindowStation;
	alias OpenWindowStationA OpenWindowStation;
	alias EnumWindowStationsA EnumWindowStations;

alias GetUserObjectInformationA GetUserObjectInformation;
alias SetUserObjectInformationA SetUserObjectInformation;
alias RegisterWindowMessageA RegisterWindowMessage;
alias GetMessageA GetMessage;
alias DispatchMessageA DispatchMessage;
alias PeekMessageA PeekMessage;
alias SendMessageA SendMessage;
alias SendMessageTimeoutA SendMessageTimeout;
alias SendNotifyMessageA SendNotifyMessage;
alias SendMessageCallbackA SendMessageCallback;
alias BroadcastSystemMessageA BroadcastSystemMessage;
alias PostMessageA PostMessage;
alias PostThreadMessageA PostThreadMessage;
alias PostAppMessageA PostAppMessage;
alias DefWindowProcA DefWindowProc;
alias CallWindowProcA CallWindowProc;
alias RegisterClassA RegisterClass;
alias UnregisterClassA UnregisterClass;
alias GetClassInfoA GetClassInfo;
alias RegisterClassExA RegisterClassEx;
alias GetClassInfoExA GetClassInfoEx;
alias CreateWindowExA CreateWindowEx;
alias CreateWindowA CreateWindow;
alias CreateDialogParamA CreateDialogParam;
alias CreateDialogIndirectParamA CreateDialogIndirectParam;
alias DialogBoxParamA DialogBoxParam;
alias DialogBoxIndirectParamA DialogBoxIndirectParam;
alias SetDlgItemTextA  SetDlgItemText;
alias GetDlgItemTextA  GetDlgItemText;
alias SendDlgItemMessageA  SendDlgItemMessage;
alias DefDlgProcA  DefDlgProc;
alias CallMsgFilterA  CallMsgFilter;
alias RegisterClipboardFormatA  RegisterClipboardFormat;
alias GetClipboardFormatNameA  GetClipboardFormatName;
alias CharToOemA  CharToOem;
alias OemToCharA  OemToChar;
alias CharToOemBuffA  CharToOemBuff;
alias OemToCharBuffA  OemToCharBuff;
alias CharUpperA  CharUpper;
alias CharUpperBuffA  CharUpperBuff;
alias CharLowerA  CharLower;
alias CharLowerBuffA  CharLowerBuff;
alias CharNextA  CharNext;
alias CharPrevA  CharPrev;
alias IsCharAlphaA  IsCharAlpha;
alias IsCharAlphaNumericA  IsCharAlphaNumeric;
alias IsCharUpperA  IsCharUpper;
alias IsCharLowerA  IsCharLower;
alias GetKeyNameTextA  GetKeyNameText;
alias VkKeyScanA  VkKeyScan;
alias VkKeyScanExA  VkKeyScanEx;
alias MapVirtualKeyA MapVirtualKey;
alias MapVirtualKeyExA  MapVirtualKeyEx;
alias LoadAcceleratorsA  LoadAccelerators;
alias CreateAcceleratorTableA  CreateAcceleratorTable;
alias CopyAcceleratorTableA  CopyAcceleratorTable;
alias TranslateAcceleratorA  TranslateAccelerator;
alias LoadMenuA  LoadMenu;
alias LoadMenuIndirectA  LoadMenuIndirect;
alias ChangeMenuA  ChangeMenu;
alias GetMenuStringA  GetMenuString;
alias InsertMenuA  InsertMenu;
alias AppendMenuA  AppendMenu;
alias ModifyMenuA  ModifyMenu;

alias InsertMenuItemA InsertMenuItem;
alias GetMenuItemInfoA  GetMenuItemInfo;
alias SetMenuItemInfoA  SetMenuItemInfo;
alias DrawTextA  DrawText;
alias DrawTextExA  DrawTextEx;
alias GrayStringA  GrayString;
alias DrawStateA  DrawState;
alias TabbedTextOutA TabbedTextOut;
alias GetTabbedTextExtentA  GetTabbedTextExtent;
alias SetPropA  SetProp;
alias GetPropA  GetProp;
alias RemovePropA  RemoveProp;
alias EnumPropsExA  EnumPropsEx;
alias EnumPropsA  EnumProps;
alias SetWindowTextA  SetWindowText;
alias GetWindowTextA  GetWindowText;
alias GetWindowTextLengthA  GetWindowTextLength;
alias MessageBoxA  MessageBox;
alias MessageBoxExA  MessageBoxEx;
alias MessageBoxIndirectA  MessageBoxIndirect;
alias GetWindowLongA  GetWindowLong;
alias SetWindowLongA  SetWindowLong;
alias GetClassLongA  GetClassLong;
alias SetClassLongA  SetClassLong;
alias FindWindowA FindWindow;
alias FindWindowExA  FindWindowEx;
alias GetClassNameA  GetClassName;
alias SetWindowsHookA  SetWindowsHook;
alias SetWindowsHookExA  SetWindowsHookEx;
alias LoadBitmapA  LoadBitmap;
alias LoadCursorA  LoadCursor;
alias LoadCursorFromFileA  LoadCursorFromFile;
alias LoadIconA  LoadIcon;
alias LoadImageA  LoadImage;
alias LoadStringA  LoadString;
alias IsDialogMessageA  IsDialogMessage;
alias DlgDirListA  DlgDirList;
alias DlgDirSelectExA  DlgDirSelectEx;
alias DlgDirListComboBoxA  DlgDirListComboBox;
alias DlgDirSelectComboBoxExA  DlgDirSelectComboBoxEx;
alias DefFrameProcA  DefFrameProc;
alias DefMDIChildProcA  DefMDIChildProc;
alias CreateMDIWindowA  CreateMDIWindow;
alias WinHelpA  WinHelp;
alias ChangeDisplaySettingsA  ChangeDisplaySettings;
alias ChangeDisplaySettingsExA  ChangeDisplaySettingsEx;
alias EnumDisplaySettingsA  EnumDisplaySettings;
alias SystemParametersInfoA  SystemParametersInfo;

alias GetBinaryTypeA  GetBinaryType;
alias GetShortPathNameA  GetShortPathName;
alias FreeEnvironmentStringsA  FreeEnvironmentStrings;
alias CreateMailslotA  CreateMailslot;
alias lstrcmpA  lstrcmp;
alias lstrcmpiA  lstrcmpi;
alias lstrcpynA  lstrcpyn;
alias lstrcpyA  lstrcpy;
alias lstrcatA  lstrcat;
alias lstrlenA  lstrlen;
alias CreateMutexA  CreateMutex;
alias OpenMutexA  OpenMutex;
alias CreateEventA  CreateEvent;
alias OpenEventA  OpenEvent;
alias CreateSemaphoreA  CreateSemaphore;
alias OpenSemaphoreA  OpenSemaphore;
alias CreateWaitableTimerA  CreateWaitableTimer;
alias OpenWaitableTimerA  OpenWaitableTimer;
alias CreateFileMappingA  CreateFileMapping;
alias OpenFileMappingA  OpenFileMapping;
alias GetLogicalDriveStringsA  GetLogicalDriveStrings;
alias LoadLibraryA  LoadLibrary;
alias LoadLibraryExA  LoadLibraryEx;
alias GetModuleFileNameA  GetModuleFileName;
alias GetModuleHandleA GetModuleHandle;
alias CreateProcessA  CreateProcess;
alias FatalAppExitA  FatalAppExit;
alias GetStartupInfoA  GetStartupInfo;
alias GetCommandLineA  GetCommandLine;
alias GetEnvironmentVariableA  GetEnvironmentVariable;
alias SetEnvironmentVariableA  SetEnvironmentVariable;
alias ExpandEnvironmentStringsA  ExpandEnvironmentStrings;
alias OutputDebugStringA  OutputDebugString;
alias FindResourceA  FindResource;
alias FindResourceExA  FindResourceEx;
alias EnumResourceTypesA  EnumResourceTypes;
alias EnumResourceNamesA  EnumResourceNames;
alias EnumResourceLanguagesA  EnumResourceLanguages;
alias BeginUpdateResourceA  BeginUpdateResource;
alias UpdateResourceA  UpdateResource;
alias EndUpdateResourceA  EndUpdateResource;
alias GlobalAddAtomA  GlobalAddAtom;
alias GlobalFindAtomA  GlobalFindAtom;
alias GlobalGetAtomNameA  GlobalGetAtomName;
alias AddAtomA  AddAtom;
alias FindAtomA  FindAtom;
alias GetAtomNameA  GetAtomName;
alias GetProfileIntA  GetProfileInt;
alias GetProfileStringA  GetProfileString;
alias WriteProfileStringA  WriteProfileString;
alias GetProfileSectionA  GetProfileSection;
alias WriteProfileSectionA  WriteProfileSection;
alias GetPrivateProfileIntA  GetPrivateProfileInt;
alias GetPrivateProfileStringA  GetPrivateProfileString;
alias WritePrivateProfileStringA  WritePrivateProfileString;
alias GetPrivateProfileSectionA  GetPrivateProfileSection;
alias WritePrivateProfileSectionA  WritePrivateProfileSection;
alias GetPrivateProfileSectionNamesA  GetPrivateProfileSectionNames;
alias GetPrivateProfileStructA  GetPrivateProfileStruct;
alias WritePrivateProfileStructA  WritePrivateProfileStruct;
alias GetDriveTypeA GetDriveType;
alias GetSystemDirectoryA  GetSystemDirectory;
alias GetTempPathA  GetTempPath;
alias GetTempFileNameA  GetTempFileName;
alias GetWindowsDirectoryA  GetWindowsDirectory;
alias SetCurrentDirectoryA  SetCurrentDirectory;
alias GetCurrentDirectoryA  GetCurrentDirectory;
alias GetDiskFreeSpaceA  GetDiskFreeSpace;
alias GetDiskFreeSpaceExA  GetDiskFreeSpaceEx;
alias CreateDirectoryA  CreateDirectory;
alias CreateDirectoryExA  CreateDirectoryEx;
alias RemoveDirectoryA  RemoveDirectory;
alias GetFullPathNameA  GetFullPathName;
alias DefineDosDeviceA  DefineDosDevice;
alias QueryDosDeviceA  QueryDosDevice;
alias CreateFileA  CreateFile;
alias SetFileAttributesA  SetFileAttributes;
alias GetFileAttributesA  GetFileAttributes;
alias GetFileAttributesExA  GetFileAttributesEx;
alias GetCompressedFileSizeA  GetCompressedFileSize;
alias DeleteFileA  DeleteFile;
alias FindFirstFileExA  FindFirstFileEx;
alias FindFirstFileA  FindFirstFile;
alias FindNextFileA  FindNextFile;
alias SearchPathA  SearchPath;
alias CopyFileA  CopyFile;
alias CopyFileExA CopyFileEx;
alias MoveFileA  MoveFile;
alias MoveFileExA  MoveFileEx;
alias CreateNamedPipeA  CreateNamedPipe;
alias GetNamedPipeHandleStateA  GetNamedPipeHandleState;
alias CallNamedPipeA  CallNamedPipe;
alias WaitNamedPipeA  WaitNamedPipe;
alias SetVolumeLabelA  SetVolumeLabel;
alias GetVolumeInformationA  GetVolumeInformation;
alias ClearEventLogA  ClearEventLog;
alias BackupEventLogA  BackupEventLog;
alias OpenEventLogA  OpenEventLog;
alias RegisterEventSourceA  RegisterEventSource;
alias OpenBackupEventLogA  OpenBackupEventLog;
alias ReadEventLogA  ReadEventLog;
alias ReportEventA  ReportEvent;
alias AccessCheckAndAuditAlarmA  AccessCheckAndAuditAlarm;
alias ObjectOpenAuditAlarmA  ObjectOpenAuditAlarm;
alias ObjectPrivilegeAuditAlarmA  ObjectPrivilegeAuditAlarm;
alias ObjectCloseAuditAlarmA  ObjectCloseAuditAlarm;
alias ObjectDeleteAuditAlarmA  ObjectDeleteAuditAlarm;
alias PrivilegedServiceAuditAlarmA  PrivilegedServiceAuditAlarm;
alias SetFileSecurityA  SetFileSecurity;
alias GetFileSecurityA  GetFileSecurity;
alias FindFirstChangeNotificationA  FindFirstChangeNotification;
alias IsBadStringPtrA  IsBadStringPtr;
alias LookupAccountSidA  LookupAccountSid;
alias LookupAccountNameA  LookupAccountName;
alias LookupPrivilegeValueA  LookupPrivilegeValue;
alias LookupPrivilegeNameA  LookupPrivilegeName;
alias LookupPrivilegeDisplayNameA  LookupPrivilegeDisplayName;
alias BuildCommDCBA  BuildCommDCB;
alias BuildCommDCBAndTimeoutsA  BuildCommDCBAndTimeouts;
alias CommConfigDialogA  CommConfigDialog;
alias GetDefaultCommConfigA  GetDefaultCommConfig;
alias SetDefaultCommConfigA  SetDefaultCommConfig;
alias GetComputerNameA  GetComputerName;
alias SetComputerNameA  SetComputerName;
alias GetUserNameA  GetUserName;
alias LogonUserA  LogonUser;
alias CreateProcessAsUserA  CreateProcessAsUser;
alias GetCurrentHwProfileA GetCurrentHwProfile;

alias AddFontResourceA  AddFontResource;
alias CopyMetaFileA  CopyMetaFile;
alias CreateDCA  CreateDC;
alias CreateFontIndirectA  CreateFontIndirect;
alias CreateFontA  CreateFont;
alias CreateICA  CreateIC;
alias CreateMetaFileA  CreateMetaFile;
alias CreateScalableFontResourceA  CreateScalableFontResource;
alias DeviceCapabilitiesA  DeviceCapabilities;
alias EnumFontFamiliesExA  EnumFontFamiliesEx;
alias EnumFontFamiliesA EnumFontFamilies;
alias EnumFontsA  EnumFonts;
alias GetCharWidthA  GetCharWidth;
alias GetCharWidth32A  GetCharWidth32;
alias GetCharWidthFloatA  GetCharWidthFloat;
alias GetCharABCWidthsA  GetCharABCWidths;
alias GetCharABCWidthsFloatA  GetCharABCWidthsFloat;
alias GetGlyphOutlineA  GetGlyphOutline;
alias GetMetaFileA GetMetaFile;
alias GetOutlineTextMetricsA  GetOutlineTextMetrics;
alias GetTextExtentPointA  GetTextExtentPoint;
alias GetTextExtentPoint32A  GetTextExtentPoint32;
alias GetTextExtentExPointA  GetTextExtentExPoint;
alias GetCharacterPlacementA  GetCharacterPlacement;
alias ResetDCA  ResetDC;
alias RemoveFontResourceA  RemoveFontResource;
alias CopyEnhMetaFileA  CopyEnhMetaFile;
alias CreateEnhMetaFileA  CreateEnhMetaFile;
alias GetEnhMetaFileA  GetEnhMetaFile;
alias GetEnhMetaFileDescriptionA  GetEnhMetaFileDescription;
alias GetTextMetricsA  GetTextMetrics;
alias StartDocA  StartDoc;
alias GetObjectA  GetObject;
alias TextOutA  TextOut;
alias ExtTextOutA  ExtTextOut;
alias PolyTextOutA  PolyTextOut;
alias GetTextFaceA  GetTextFace;
alias GetKerningPairsA  GetKerningPairs;
alias GetLogColorSpaceA  GetLogColorSpace;
alias CreateColorSpaceA  CreateColorSpace;
alias GetICMProfileA GetICMProfile;
alias SetICMProfileA  SetICMProfile;
alias EnumICMProfilesA  EnumICMProfiles;
alias wglUseFontBitmapsA  wglUseFontBitmaps;
alias wglUseFontOutlinesA  wglUseFontOutlines;


// !!! this is the way MS headers define it
// it appears that GetEnvironmentStrings has a missing 'A'
// so in unicode builds 'GetEnvironmentStrings' will NOT
// call GetEnvironmentStringsW !!
alias GetEnvironmentStrings GetEnvironmentStringsA;

} // extern(Windows)
} // version(UNICODE)
